#ifndef TELNET_H_
#define TELNET_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <inttypes.h>

#ifdef HAVE_WINSOCK2_H
#include <winsock2.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#elif _WIN
#include <compat.h>
#endif

#ifndef _WIN
#include <netdb.h>
#endif

#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#endif

#define MAXPATHLEN 1025

typedef struct {
	int		id;
	struct sockaddr_in clientSocket;
	int		socketlen;
	int		sockfd;
	char	buffer[MAXPATHLEN];
	char	*cmd_ptr;

#ifdef HAVE_PTHREAD_H
	pthread_t thread;
	pthread_attr_t attr;
#endif
} client_t;

typedef struct {
	uint8_t enabled;
	char    *host;
	uint16_t port;
	char    *password;
	int	sockfd;
	uint8_t max_conn;
	uint8_t clients;
	client_t **client_pool;
#ifdef HAVE_PTHREAD_H
	pthread_mutex_t thread_mutex;
#endif
} telnet_t;

extern telnet_t *telnet;



#define DEFAULT_MAX_THREADS	10
#define DEFAULT_PORT		10006
#define DEFAULT_HOST		"127.0.0.1"


telnet_t *telnetDefaults();
void *telnetListener(void *t);
void telnetCloser(telnet_t *t);

#endif /*TELNET_H_*/
